#!/bin/bash
if [ -z "$EXP_DIR" ]
then
    EXP_DIR=~
fi

echo "EXP_DIR: $EXP_DIR"
cd $EXP_DIR/pymarl

mkdir 3rdparty
cd 3rdparty

export SC2PATH=`pwd`'/StarCraftII'
echo 'SC2PATH is set to '$SC2PATH

if [ ! -d $SC2PATH ]; then
        echo 'StarCraftII is not installed. Installing now ...';
         wget https://blzdistsc2-a.akamaihd.net/Linux/SC2.4.9.2.zip
        unzip -qP iagreetotheeula SC2.4.9.2.zip
        mv SC2.4.9.2/StarCraftII StarCraftII/
        rm -rf SC2.4.9.2
         rm -rf SC2.4.10.zip
else
        echo 'StarCraftII is already installed.'
fi
chmod +x $SC2PATH/Versions/Base74741/SC2_x64

echo 'Adding SMAC maps.'
MAP_DIR="$SC2PATH/Maps/"
echo 'MAP_DIR is set to '$MAP_DIR

if [ ! -d $MAP_DIR ]; then
        mkdir -p $MAP_DIR
fi
cd ..

wget https://github.com/oxwhirl/smac/releases/download/v0.1-beta1/SMAC_Maps.zip
unzip SMAC_Maps.zip
mv SMAC_Maps $MAP_DIR
rm -rf SMAC_Maps.zip
echo 'StarCraft II and SMAC are installed.'